# Supplementary Material for IMVIP Submission 22

As supplementary material we provide the zip file **DFNet.zip**

It includes:
- **Documentation:** README.md (this file)
- **Models:** The DF-Net comprising the sub-models M1 and M2 (in TensorFlow format)
- **Docker-Image:** Dockerfile and code to create an independent docker container to easily test the DF-Net and reproduce results on the benchmark dataset 
- **Jupyter Notebook:** Interactive way to test DF-Net and visualize examples
- **Testdata:** Copy of the benchmark dataset CASIA (due to space restrictions only a subset of the CASIA V1 benchmark dataset is used)



## HowTo: Test DF-Net in Docker container

Download und extract the file **DFNet.zip** to an environment supporting Docker, ideally in a Linux-based system with GPU support ($ = command prompt):

### Install zip tool (if not already available):
    $ sudo apt install zip

### Unpack zip:
    $ unzip DFNet.zip

### Change Directory:
    $ cd IMVIP_Supplementary_Material

### BUILD Docker Image

    $ ./scripts/build_image.sh

### RUN Docker Container with or without GPU

    $ ./scripts/run_container.sh
    or
    $ ./scripts/run_container_NO_GPU.sh  

### Open Jupyter Notebook

In a browser, open the link that was printed in your console (should look similar to *http://127.0.0.1:8888/?token=73a6fd55dacf4984f616fe60838d64e96abba2087a6cfbda*) 

On the webpage, click on the folder **dfnet** and then the Jupyter notebook **IMVIP_Model_Evaluation.ipynb**

### Execute Code

Run all code blocks (by pressing shift+enter for each block).
Examples from the CASIA benchmark dataset will be displayed on the screen.

### Parameter Setting

To control the number of processed images (*MAX_EXAMPLES*) and define how many images are displayed (*SHOW_NTH_RESULT*), you can modify the corresponding variables at the bottom of the Jupyter page.

    SHOW_NTH_RESULT = 1 # defines how many results are shown: 1...show each result;  n...only show n-th result
    MAX_EXAMPLES = 20   # defines number of images to process:  np.infty...all images in folder are processed


## Folder Structure for Supplementary Material

```.
├── datasets
│   │   
│   └── benchmark
│       ├── CASIA
│       └── CASIA_GT
├── models
│   ├── model1
│   └── model2
└── scripts
```